Oracle Coherence for C++ API
Release 3.6.0.0
E15728-01

- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# WrapperCollections::AbstractWrapperMap Class Reference

`#include <coherence/util/WrapperCollections.hpp>`

Inherits Object, and Map.

Inherited by ConverterCollections::ConverterMap, and TypedCollections::TypedMap.

List of all members.

## Detailed Description

Map implementation which delegates all calls to another Map.

## Public Types
typedef spec::Handle | Handle
| AbstractWrapperMap Handle definition.
typedef spec::View | View
| AbstractWrapperMap View definition.
typedef spec::Holder | Holder
| AbstractWrapperMap Holder definition.
## Public Member Functions
virtual size32_t | size () const
| Return the number of key-value mappings in this map. Returns: the number of key-value mappings in this map.
virtual bool | isEmpty () const
| Return `true` if this map contains no key-value mappings. Returns: `true` if this map contains no key-value mappings.
virtual bool | containsKey (Object::View vKey) const
  | Return `true` if this map contains a mapping for the specified key. Parameters:
  | vKey | key whose presence in this map is to be tested.
Returns: `true` if this map contains a mapping for the specified key.
virtual bool | containsValue (Object::View vValue) const
  | Return `true` if this map maps one or more keys to the specified value. This operation will probably require time linear in the map size for most implementations of the `Map` interface. Parameters:
  | vValue | value whose presence in this map is to be tested.
Returns: `true` if this map maps one or more keys to the specified value.
virtual Object::Holder | get (Object::View vKey) const
  | Return the value to which this map maps the specified key. Return `NULL` if the map contains no mapping for this key. A return value of `NULL` does not necessarily indicate that the map contains no mapping for the key; it's also possible that the map explicitly maps the key to `NULL`. The `containsKey` operation may be used to distinguish these two cases. Parameters:
  | vKey | key whose associated value is to be returned.
Returns: the value to which this map maps the specified key, or `NULL` if the map contains no mapping for this key. See also: containsKey()
virtual Object::Holder | get (Object::View vKey)
  | Return the value to which this map maps the specified key. Return `NULL` if the map contains no mapping for this key. A return value of `NULL` does not necessarily indicate that the map contains no mapping for the key; it's also possible that the map explicitly maps the key to `NULL`. The `containsKey` operation may be used to distinguish these two cases. Parameters:
  | vKey | key whose associated value is to be returned.
Returns: the value to which this map maps the specified key, or `NULL` if the map contains no mapping for this key. See also: containsKey()
virtual Object::Holder | put (Object::View vKey, Object::Holder ohValue)
  | Associate the specified value with the specified key in this map. If the map previously contained a mapping for this key, the old value is replaced by the specified value. Parameters:
  | vKey | key with which the specified value is to be associated.
  | ohValue | value to be associated with the specified key.
  Returns: previous value associated with specified key, or `NULL` if there was no mapping for key. A `NULL` return can also indicate that the map previously associated `NULL` with the specified key. Exceptions:
  | coherence::lang::UnsupportedOperationException | if the put() operation is not supported by this map.
virtual Object::Holder | remove (Object::View vKey)
  | Remove the mapping for this key from this map if it is present. Return the value to which the map previously associated the key, or `NULL` if the map contained no mapping for this key. (A `NULL` return can also indicate that the map previously associated `NULL` with the specified key.) The map will not contain a mapping for the specified key once the call returns. Parameters:
  | vKey | key whose mapping is to be removed from the map.
  Returns: previous value associated with specified key, or `NULL` if there was no mapping for key. Exceptions:
  | coherence::lang::UnsupportedOperationException | if the remove() operation is not supported by this map.
virtual void | putAll (Map::View vMap)
  | Copy all of the mappings from the specified map to this map. The effect of this call is equivalent to that of calling put(k, v) on this map once for each mapping from key `k` to value `v` in the specified map. The behavior of this operation is unspecified if the specified map is modified while the operation is in progress. Parameters:
  | vMap | mappings to be stored in this map.
  Exceptions:
  | coherence::lang::UnsupportedOperationException | if the put() operation is not supported by this map.
virtual void | clear ()
  | Remove all mappings from this map. Exceptions:
  | coherence::lang::UnsupportedOperationException | if the clear()operation is not supported by this map.
virtual Set::View | keySet () const
| Return a set of the keys contained in this map. The set is backed by the map, so changes to the map are reflected in the set. If the map is modified while an iteration over the set is in progress, the results of the iteration are undefined. Returns: a set of the keys contained in this map.
virtual Set::Handle | keySet ()
| Return a set of the keys contained in this map. The set is backed by the map, so changes to one are reflected in the other. If the map is modified while an iteration over the set is in progress, the results of the iteration are undefined. Returns: a set of the keys contained in this map.
virtual Collection::View | values () const
| Return a collection of the values contained in this map. The collection is backed by the map, so changes to the map are reflected in the set. If the map is modified while an iteration over the collection is in progress, the results of the iteration are undefined. Returns: a collection of the values contained in this map.
virtual Collection::Handle | values ()
| Return a collection of the values contained in this map. The collection is backed by the map, so changes to one are reflected in the other. If the map is modified while an iteration over the collection is in progress, the results of the iteration are undefined. Returns: a collection of the values contained in this map.
virtual Set::View | entrySet () const
| Return a set of the mappings contained in this map. Each element in the returned set is a Map::Entry::View. The set is backed by the map, so changes to the map are reflected in the set. If the map is modified while an iteration over the set is in progress, the results of the iteration are undefined. Returns: a set of the mappings contained in this map.
virtual Set::Handle | entrySet ()
| Return a set of the mappings contained in this map. Each element in the returned set is a Map::Entry::Handle. The set is backed by the map, so changes to one are reflected in the other. If the map is modified while an iteration over the set is in progress, the results of the iteration are undefined. Returns: a set of the mappings contained in this map.
virtual void | toStream (std::ostream &out) const
| Output a human-readable description of this Object to the given stream. coherence::lang::operator<<(std::ostream, Object::View) is defined and will call into the toStream method, to output Objects. If a managed String object is desired, the COH_TO_STRING macro can be used to build up a String from streamable contents.
     Object::View vKey   = ...
     Object::View vValue = ...
     std::cout << vKey << " = " << vValue << std::endl;

     String::Handle hs = COH_TO_STRING(vKey << " = " << vValue);
  Parameters:
  | out | the stream used to output the description
virtual size32_t | hashCode () const
| Return a hash code value for the Object. This method is supported for the benefit of hash-based containers. The general contract of `hashCode` is: Whenever it is invoked on the same Object more than once during an execution of an application, the `hashCode` method must consistently return the same value, provided no information used in `equals` comparisons on the object is modified. This value need not remain consistent from one execution of an application to another execution of the same application. If two Objects are equal according to the `equals` method, then calling the `hashCode` method on each of the two Objects must produce the same value. It is not required that if two Objects are unequal according to the `equals` method, then calling the `hashCode` method on each of the two objects must produce distinct results. However, the programmer should be aware that producing distinct results for unequal objects may improve the performance of hash-based containers. The default implementation is identity based. Returns: a hash code value for this Object
virtual bool | equals (Object::View v) const
virtual bool | isImmutable () const
| Return `true` iff no further changes can be made to the Object, that would effect the outcome of a call to its equals method. Except for Objects which are naturally immutable (such as String), being immutable generally implies that the Object is only referenced via const pointers or views. Objects which hold references to child Objects, may need to take the immutability of their children into account when determining their own immutability. This extended check is not performed by the default implementation, but can be integrated into the immutability checks by overriding this method, as well as making use of MemberHandles to reference child Objects. A typical derived implementation may look as follows:
     bool isImmutable() const
         {
         if (m_fImmutable) // check recorded state
             {
             return true; // already marked as immutable, avoid calculation
             }
         else if (Object::isImmutable()) // ensure shallow immutability
             {
             // ensure deep immutability
             if (m_child1->isImmutable() && m_child2->isImmutable() ...
                                         && m_childN->isImmutable())
                 {
                 // record and return immutability
                 return m_fImmutable = true;
                 }
             // some Objects which comprise this Object are still mutable
             }
         return false;
         }
The default implementation return true iff the Object is only referenced via const pointers and or views. Returns: true iff the Object is immutable
## Protected Member Functions
| AbstractWrapperMap (Map::Holder ohMapDelegate)
| Create an AbstractWrapperMap which delegates to the specified Map.
| AbstractWrapperMap (const AbstractWrapperMap &that)
| Copy constructor.
virtual Map::Handle | getDelegate ()
| Return a handle to the delegate.
virtual Map::View | getDelegate () const
| Return a view to the delegate.

## Constructor & Destructor Documentation

AbstractWrapperMap | ( | Map::Holder | ohMapDelegate | ) | `[protected]`

Create an AbstractWrapperMap which delegates to the specified Map.

Parameters:

  | ohMapDelegate | the Map to delegate to

## Member Function Documentation

virtual Map::Handle getDelegate | ( |  | ) | `[protected, virtual]`

Return a handle to the delegate.

Returns:
  the delegate handle

Exceptions:

  | UnsupportedOperationException | if the delegate is a view

virtual Map::View getDelegate | ( |  | ) | const `[protected, virtual]`

Return a view to the delegate.

Returns:
  the delegate view

The documentation for this class was generated from the following file:

- coherence/util/WrapperCollections.hpp

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.